function pad(c) {
    var i = parseInt(c, 10);
    return (i < 10 ? '0' + i : c.toString());
}

function checkForResetTemporaryHoliday() {
	lInfo.logln ('checkForResetTemporaryHoliday');
	try {
		if (Property.getNode('/scripts/system-addon-presence-simulator/temporaryHoliday/until')==null)
			return;
		var iNow=Math.floor(((new Date()).getTime())/1000);	
		var iPreheatingTime=0;
		if (Property.getNode('generalSettings/preheatingTime')!=null)
			iPreheatingTime=Property.getProperty('generalSettings/preheatingTime');
		var iTargetDate=Property.getProperty('/scripts/system-addon-presence-simulator/temporaryHoliday/until')-iPreheatingTime;
		if (iTargetDate<iNow) {
			lInfo.logln('temporary Holiday minus preheating time is now expiered, reset directly the holiday');
			new Event('heating-controller.operation-mode',{actions:'resetOperationMode',zoneID:0,operationMode:OperationModes.Holiday}).raise();
			return;
		}
		lInfo.logln('schedule the temporary holiday - reset');
		if (Property.getNode('dynamic/scheduledPreheatingTemporaryEvents/reset')!=null) {
			var propNode = Property.getNode('/system/EventInterpreter/ScheduledEvents/' + Property.getProperty('dynamic/scheduledPreheatingTemporaryEvents/reset'));
			if (propNode) {
				propNode.getParent().removeChild(propNode);
			}
			Property.getNode('dynamic/scheduledPreheatingTemporaryEvents').removeChild('reset');
		}
		var dold=new Date((iTargetDate*1000));
		var iCalStartTime = dold.getFullYear() + pad(dold.getMonth() + 1) + pad(dold.getDate()) + 'T' + pad(dold.getHours()) + pad(dold.getMinutes())
		+ pad(dold.getSeconds());
		var sRule="FREQ=DAILY;COUNT=1";				
		var actionParameter = {
				'zoneID' : 0,
				'actions':'resetOperationMode',
				'operationMode':OperationModes.Holiday
			}		
		lInfo.logln('schedule reset for holiday on ' + iCalStartTime);
		var timerEvent = new TimedICalEvent('heating-controller.operation-mode', iCalStartTime, sRule, actionParameter);
		Property.setProperty('dynamic/scheduledPreheatingTemporaryEvents/reset', timerEvent.raise());
	}
	catch (e) {
		lWarn.logln('error on checkForTemporaryHoliday ' + e);
	}
}

function checkForSetTemporaryHoliday() {
    try {
        lInfo.logln ('checkForSetTemporaryHoliday');
        if (Property.getNode('dynamic/scheduledPreheatingTemporaryEvents')!=null) {
            lInfo.logln('Remove holiday nodes');
            var oNodes=Property.getNode('dynamic/scheduledPreheatingTemporaryEvents').getChildren();
            lInfo.logln('Remove holiday nodes count ' + oNodes.length);
            for (var iIndex=0;iIndex<oNodes.length;iIndex++) {
                lInfo.logln('Remove node '+ oNodes[iIndex].getValue());
                var propNode=Property.getNode('/system/EventInterpreter/ScheduledEvents/' + oNodes[iIndex].getValue());
                if (propNode) {
                    propNode.getParent().removeChild(propNode);
                }

            }
        }
        if (Property.getNode('dynamic')) {
            Property.getNode('dynamic').removeChild('scheduledPreheatingTemporaryEvents');
        }
        if (Property.getNode('/scripts/system-addon-presence-simulator/temporaryHoliday/from')==null)
            return;
        var iNow=Math.floor(((new Date()).getTime())/1000);	
        var iTargetDate=Property.getProperty('/scripts/system-addon-presence-simulator/temporaryHoliday/from');
        if (iTargetDate<iNow) {
            lInfo.logln('temporary Holiday time is now in effect, set directly the holiday');
            new Event('heating-controller.operation-mode',{actions:'setOperationMode',zoneID:0,operationMode:OperationModes.Holiday}).raise();

            if (Property.getProperty('/scripts/system-addon-presence-simulator/temporaryHoliday/until')!=null) {
                var iTargetDate=Property.getProperty('/scripts/system-addon-presence-simulator/temporaryHoliday/until');			
                var dold=new Date((iTargetDate*1000));
                new Event('AddonToCloud',{"EventName":"ReturnTime","returnOn":dold.toISOString()}).raise();
            }

            return;
        }

        lInfo.logln('schedule the temporary holiday - set');
        if (Property.getNode('dynamic/scheduledPreheatingTemporaryEvents/set')!=null) {
            var propNode = Property.getNode('/system/EventInterpreter/ScheduledEvents/' + Property.getProperty('dynamic/scheduledPreheatingTemporaryEvents/set'));
            if (propNode) {
                propNode.getParent().removeChild(propNode);			
            }
            Property.getNode('dynamic/scheduledPreheatingTemporaryEvents').removeChild('set');
        }

        var dold=new Date((iTargetDate*1000));
        var iCalStartTime = dold.getFullYear() + pad(dold.getMonth() + 1) + pad(dold.getDate()) + 'T' + pad(dold.getHours()) + pad(dold.getMinutes())
        + pad(dold.getSeconds());
        var sRule="FREQ=DAILY;COUNT=1";				
        var actionParameter = {
                'zoneID' : 0,
                'actions' : 'setOperationMode',
                'operationMode':OperationModes.Holiday
            };		
        lInfo.logln('schedule set for holiday on ' + iCalStartTime);
        timerEvent = new TimedICalEvent('heating-controller.operation-mode', iCalStartTime, sRule, actionParameter);
        Property.setProperty('dynamic/scheduledPreheatingTemporaryEvents/set', timerEvent.raise());
        if (Property.getProperty('/scripts/system-addon-presence-simulator/temporaryHoliday/until')!=null) {
            var iTargetDate=Property.getProperty('/scripts/system-addon-presence-simulator/temporaryHoliday/until');			
            var dold=new Date((iTargetDate*1000));
            timerEvent = new TimedICalEvent('AddonToCloud', iCalStartTime, sRule, {"EventName":"ReturnTime","returnOn":dold.toISOString()});
            Property.setProperty('dynamic/scheduledPreheatingTemporaryEvents/cloud', timerEvent.raise());
        }
    } catch (e) {
        lWarn.logln('error on checkForSetTemporaryHoliday ' + e);
    }
}

function checkForRegularyHoliday() {
    try {
	lInfo.logln ('checkForRegularyHoliday');
	
	if (Property.getNode('dynamic/scheduledPreheatingHolidayEvents')!=null) {
		lInfo.logln('Remove holiday nodes');
		var oNodes=Property.getNode('dynamic/scheduledPreheatingHolidayEvents').getChildren();
		lInfo.logln('Remove holiday nodes count ' + oNodes.length);
		for (var iIndex=0;iIndex<oNodes.length;iIndex++) {
			lInfo.logln('Remove node '+ oNodes[iIndex].getValue());
			var propNode=Property.getNode('/system/EventInterpreter/ScheduledEvents/' + oNodes[iIndex].getValue());
			if (propNode) {
				propNode.getParent().removeChild(propNode);
			}
			
		}
	}
    if (Property.getNode('dynamic')) {
        Property.getNode('dynamic').removeChild('scheduledPreheatingHolidayEvents');
    }
	var iPreheatingTime=0;
	if (Property.getNode('generalSettings/preheatingTime')!=null)
		iPreheatingTime=Property.getProperty('generalSettings/preheatingTime');	
	
	if (Property.getNode('/scripts/system-addon-presence-simulator/values/holiday')) {
        var oArray=Property.getNode('/scripts/system-addon-presence-simulator/values/holiday').getChildren();
        var iNow=Math.floor(((new Date()).getTime())/1000);	
        for (var iIndex=0;iIndex<oArray.length;iIndex++) {
            var oNode=oArray[iIndex];
            var iVon=oNode.getChild('von').getValue();
            var iBis=oNode.getChild('bis').getValue();
            var id=oNode.getChild('id').getValue();
            var iCalStartStartTime;
            if ((iBis-iPreheatingTime)>iNow) {
                if (iVon>iNow)  {				
                    var dold=new Date((iVon*1000));
                    iCalStartStartTime = dold.getFullYear() + pad(dold.getMonth() + 1) + pad(dold.getDate()) + 'T' + pad(dold.getHours()) + pad(dold.getMinutes())
                        + pad(dold.getSeconds());
                    var sRule="FREQ=DAILY;COUNT=1";				
                    var actionParameter = {
                            'zoneID' : 0,
                            'actions' : 'setOperationMode',
                            'operationMode':OperationModes.Holiday
                        };	


                    lInfo.logln('schedule set for holiday on ' + iCalStartStartTime);
                    timerEvent = new TimedICalEvent('heating-controller.operation-mode', iCalStartStartTime, sRule, actionParameter);
                    Property.setProperty('dynamic/scheduledPreheatingHolidayEvents/set' + id, timerEvent.raise());

                } else {
                    lInfo.logln('Holiday in effect, just remember the holiday mode and schedule the end');
                } 



                var sRule="FREQ=DAILY;COUNT=1";					
                var dold=new Date(iBis*1000);
                if (iCalStartStartTime==null) {
                    new Event('AddonToCloud',{"EventName":"ReturnTime","returnOn":dold.toISOString()}).raise();
                }  else {
                    var returnTime = new TimedICalEvent('AddonToCloud', iCalStartStartTime, sRule, {"EventName":"ReturnTime","returnOn":dold.toISOString()});
                    Property.setProperty('dynamic/scheduledPreheatingHolidayEvents/cloud' + id, timerEvent.raise());
                }

                dold=new Date(((iBis-iPreheatingTime)*1000));
                var iCalStartTime = dold.getFullYear() + pad(dold.getMonth() + 1) + pad(dold.getDate()) + 'T' + pad(dold.getHours()) + pad(dold.getMinutes())
                    + pad(dold.getSeconds());
                var sRule="FREQ=DAILY;COUNT=1";				
                var actionParameter = {
                        'zoneID' : 0,
                        'actions' : 'resetOperationMode',
                        'operationMode':OperationModes.Holiday
                    };	
                lInfo.logln('schedule reset for holiday on ' + iCalStartTime);
                timerEvent = new TimedICalEvent('heating-controller.operation-mode', iCalStartTime, sRule, actionParameter);
                Property.setProperty('dynamic/scheduledPreheatingHolidayEvents/reset' + id, timerEvent.raise());
            } else {
                lInfo.logln('Holiday is expired - no actions');
            }
        }
    }
    } catch (e) {
        lWarn.logln('error on checkForRegularyHoliday ' + e);
    }
}

function checkForHolidayState() {
    try {
        lInfo.logln ('checkForHolidayState');
        var fShouldResetHoliday=false;
        var fShouldSetHoliday=false;
        var fApartmentInHoliday=(getState('operationmode.0.Holiday').getValue()==stateValues.active)
        if (fApartmentInHoliday)
            if (Property.getProperty('/usr/states/holiday/value')=='off')
                fShouldSetHoliday=true;
        if (!fApartmentInHoliday)
            if (Property.getProperty('/usr/states/holiday/value')=='on')
                fShouldResetHoliday=true;
        if (fShouldResetHoliday) {
            lInfo.logln('Holiday not in effect, but heating is still in holiday -> reseting holiday ')
            new Event('heating-controller.operation-mode',{'zoneID' : 0,
                        'actions' : 'resetOperationMode',
                        'operationMode':OperationModes.Holiday}).raise();
        } else if (fShouldSetHoliday) {
            lInfo.logln('Holiday in effect, but heating is still in on -> thats dangerous to set now holiday because of preheating time, so better skipping');
        }
    } catch (e) {
        lWarn.logln('error on checkForHolidayState ' + e);
    }
}

checkForSetTemporaryHoliday();
checkForResetTemporaryHoliday();
checkForRegularyHoliday();
checkForHolidayState();